;(use-modules (gnucash main)) ;; FIXME: delete after we finish modularizing.
;(use-modules (srfi srfi-1))
;(use-modules (ice-9 slib))
;(use-modules (gnucash gnc-module))
;(require 'printf)

;(gnc:module-load "gnucash    report    report-system" 0)
   (define gnc:split-get-guid gncSplitGetGUID)
   (define gnc:split-get-balance xaccSplitGetBalance )
   (define gnc:split-get-memo xaccSplitGetMemo)
   (define gnc:split-get-action xaccSplitGetAction)
   (define gnc:split-get-reconcile-state xaccSplitGetReconcile)
   (define gnc:split-get-reconciled-date gnc-split-get-date-reconciled)
   (define gnc:split-get-amount xaccSplitGetAmount)
   (define gnc:split-get-share-price xaccSplitGetSharePrice)
   (define gnc:split-get-value xaccSplitGetValue)
   (define gnc:split-get-account xaccSplitGetAccount)
   (define gnc:split-get-parent xaccSplitGetParent)
   (define gnc:split-get-other-split xaccSplitGetOtherSplit)
   (define gnc:split-compare-account-full-names xaccSplitCompareAccountFullNames)
   (define gnc:split-compare-account-codes xaccSplitCompareAccountCodes)
   (define gnc:split-compare-other-account-full-names xaccSplitCompareOtherAccountFullNames)
   (define gnc:split-compare-other-account-codes xaccSplitCompareOtherAccountCodes)
   (define gnc:split-get-corr-account-name xaccSplitGetCorrAccountName)
   (define gnc:split-get-corr-account-full-name-internal xaccSplitGetCorrAccountFullName)
   (define gnc:split-get-lot xaccSplitGetLot)
   (define gnc:split-void-former-amount xaccSplitVoidFormerAmount)
   (define gnc:split-destroy xaccSplitDestroy)
   (define gnc:split-create xaccMallocSplit)
   (define gnc:split-set-value xaccSplitSetValue)
   (define gnc:split-set-base-value xaccSplitSetBaseValue)
   (define gnc:split-set-memo xaccSplitSetMemo)
   (define gnc:split-set-action xaccSplitSetAction)
   (define gnc:split-set-reconcile xaccSplitSetReconcile)
   (define gnc:split-set-share-price xaccSplitSetSharePrice)
   (define gnc:split-set-amount xaccSplitSetAmount)
   (define gnc:split-set-share-price-and-amount xaccSplitSetSharePriceAndAmount)
;;    #### Transaction Stuff
   (define gnc:transaction-get-guid gncTransGetGUID)
   (define gnc:transaction-get-split xaccTransGetSplit)
   (define gnc:transaction-get-splits xaccTransGetSplitList)
   (define gnc:transaction-get-num xaccTransGetNum)
   (define gnc:transaction-get-description xaccTransGetDescription)
   (define gnc:transaction-get-notes xaccTransGetNotes)
   (define gnc:transaction-get-void-status xaccTransGetVoidStatus)
   (define gnc:transaction-order xaccTransOrder)
   (define gnc:transaction-get-date-posted gnc-transaction-get-date-posted)
   (define gnc:transaction-get-date-entered gnc-transaction-get-date-entered)
   (define gnc:transaction-get-account-value xaccTransGetAccountValue)
   (define gnc:transaction-get-txn-type xaccTransGetTxnType)
   (define gnc:transaction-destroy xaccTransDestroy)
   (define gnc:transaction-begin-edit xaccTransBeginEdit)
   (define gnc:transaction-commit-edit xaccTransCommitEdit)
   (define gnc:transaction-is-open xaccTransIsOpen)
;   (define gnc:transaction-append-split xaccTransAppendSplit)
   (define gnc:transaction-set-date  xaccTransSetDate )
   (define gnc:transaction-set-date-time-pair gnc-transaction-set-date)
   (define gnc:transaction-set-xnum xaccTransSetNum)
;   (define gnc:transaction-set-description xaccTransactionSetDescription)
   (define gnc:transaction-set-notes xaccTransSetNotes)
   (define gnc:transaction-create xaccMallocTransaction)
;;   #### Account    stuff
   (define gnc:account-get-guid gncAccountGetGUID)
   (define gnc:account-lookup xaccAccountLookup)
   (define gnc:malloc-account xaccMallocAccount )
   (define gnc:account-begin-edit xaccAccountBeginEdit)
   (define gnc:account-commit-edit xaccAccountCommitEdit)
   (define gnc:account-insert-split xaccSplitSetAccount)
   (define gnc:account-set-name xaccAccountSetName)
   (define gnc:account-set-code xaccAccountSetCode)
   (define gnc:account-set-description xaccAccountSetDescription)
   (define gnc:account-set-notes xaccAccountSetNotes)
   (define gnc:account-get-name xaccAccountGetName)
   (define gnc:account-get-code xaccAccountGetCode)
   (define gnc:account-get-description xaccAccountGetDescription)
   (define gnc:account-get-notes xaccAccountGetNotes)
   (define gnc:account-get-tax-related xaccAccountGetTaxRelated)
   (define gnc:account-get-tax-US-code xaccAccountGetTaxUSCode)
   (define gnc:account-get-tax-US-payer-name-source xaccAccountGetTaxUSPayerNameSource)
;;   (define gnc:account-get-children xaccAccountGetChildren)
;;   (define gnc:account-get-parent-account xaccAccountGetParentAccount)
;;   (define gnc:account-get-parent xaccAccountGetParent)
   (define gnc:account-get-balance  xaccAccountGetBalance )
   (define gnc:account-get-split-list  xaccAccountGetSplitList )
;;   (define gnc:get-account-from-full-name xaccGetAccountFromFullName)
;;   (define gnc:account-insert-subaccount xaccAccountInsertSubAccount)
   (define gnc:account-separator-string gnc-get-account-separator-string)
;;    #### Group stuff
;;   (define gnc:group-get-book xaccGroupGetBook)
;;   (define gnc:malloc-account-group xaccMallocAccountGroup)
;;   (define gnc:account-group-begin-edit xaccAccountGroupBeginEdit)
;;   (define gnc:account-group-destroy xaccAccountGroupDestroy)
;;   (define gnc:group-merge-accounts xaccGroupMergeAccounts)
;;   (define gnc:group-concat-group xaccGroupConcatGroup)
;;   (define gnc:group-get-num-subaccounts xaccGroupGetNumSubAccounts)
;;   (define gnc:group-get-num-accounts xaccGroupGetNumAccounts)
;;   (define gnc:group-get-account-list xaccGroupGetAccountListSorted)
;;   (define gnc:group-get-account xaccGroupGetAccount)
;;   (define gnc:group-get-parent xaccGroupGetParentAccount)
;;   (define gnc:group-insert-account xaccGroupInsertAccount)
;;   (define gnc:group-get-subaccounts xaccGroupGetSubAccountsSorted)
;;(gnc:module-load "gnucash    business-core" 0)
;;   (define gnc:lot-closed? Gnc-lot-is-closed)
;;   (define gnc:lot-get-splits gnc-lot-get-split-list)
;;   (define gnc:lot-get-balance gnc-lot-get-balance)
;;   (define gnc:budget-get-guid gncBudgetGetGUID)
;;   (define gnc:budget-lookup gnc-budget-lookup)
;;   (define gnc:budget-get- gnc-budget-get-)

  
  
   (define gnc:query-set-book    qof-query-set-book)
   (define gnc:account-get-commodity    xaccAccountGetCommodity)
   (define gnc:account-set-commodity    xaccAccountSetCommodity)
   (define gnc:transaction-get-currency    xaccTransGetCurrency)
   (define gnc:transaction-set-currency    xaccTransSetCurrency)
;   (define 'query-and    QOF-QUERY-AND)
;   (define 'query-or    QOF-QUERY-OR)
;   (define 'query-compare-equal    QOF-COMPARE-EQUAL)
;   (define '\?amt-sgn-match-either    QOF-NUMERIC-MATCH-ANY)
;   (define '\?amt-sgn-match-credit    QOF-NUMERIC-MATCH-CREDIT)
;   (define '\?amt-sgn-match-debit    QOF-NUMERIC-MATCH-DEBIT)
;   (define '\?cleared-match-no    CLEARED-NO)
;   (define '\?cleared-match-cleared    CLEARED-CLEARED)
;   (define '\?cleared-match-reconciled    CLEARED-RECONCILED)
;   (define '\?cleared-match-frozen    CLEARED-FROZEN)
;   (define '\?cleared-match-voided    CLEARED-VOIDED)
;   (define 'guid-match-all    QOF-GUID-MATCH-ALL)
;   (define 'guid-match-any    QOF-GUID-MATCH-ANY)
;   (define 'guid-match-none    QOF-GUID-MATCH-NONE)
;   (define 'query-txn-match-all    QUERY-TXN-MATCH-ALL)
;   (define 'query-txn-match-any    QUERY-TXN-MATCH-ANY)
   ;; #### Kvp Stuff
;;   (define kvp-type-gint64    KVP-TYPE-GINT64)
;;   (define kvp-type-double    KVP-TYPE-DOUBLE)
;;   (define kvp-type-numeric    KVP-TYPE-NUMERIC)
;;   (define kvp-type-string    KVP-TYPE-STRING)
;;   (define kvp-type-guid    KVP-TYPE-GUID)
;;   (define kvp-type-timespec    KVP-TYPE-TIMESPEC)
;;   (define kvp-type-binary    KVP-TYPE-BINARY)
;;   (define kvp-type-glist    KVP-TYPE-GLIST)
;;   (define kvp-type-frame    KVP-TYPE-FRAME)
   (define gnc:kvp-frame-delete-at-path    gnc-kvp-frame-delete-at-path)
   (define gnc:kvp-frame-set-slot-path    kvp-frame-set-slot-path-gslist)
   (define gnc:kvp-frame-get-slot-path    kvp-frame-get-slot-path-gslist)
   (define gnc:book-get-slots    gnc-book-get-slots)
   ;; #### QofIDType Stuff
;   (define gnc:id-book    QOF-ID-BOOK-SCM)
;   (define gnc:query-default-sort    QUERY-DEFAULT-SORT)
;   (define gnc:split-lot    SPLIT-LOT)
;   (define gnc:split-trans    SPLIT-TRANS)
;   (define gnc:split-account     SPLIT-ACCOUNT )
;   (define gnc:split-value    SPLIT-VALUE)
;   (define gnc:split-memo    SPLIT-MEMO)
;   (define gnc:split-date-reconciled    SPLIT-DATE-RECONCILED)
;   (define gnc:trans-date-posted    TRANS-DATE-POSTED)
;   (define gnc:trans-desc    TRANS-DESCRIPTION    )
;   (define gnc:trans-num    TRANS-NUM)
;;   (define gnc:account-code)    ACCOUNT-CODE-))
;   (define gnc:split-account-fullname    SPLIT-ACCT-FULLNAME)
;;   (define gnc:split-corr-account-fullname    SPLIT-CORR-ACCT-FULLNAME)
;;   (define gnc:split-corr-account-code    SPLIT-CORR-ACCT-CODE)
;;   (define gnc:invoice-from-txn    INVOICE-FROM-TXN)
;;   (define gnc:invoice-owner    INVOICE-OWNER)
;;   (define gnc:owner-parentg    OWNER-PARENTG)
;;   (define gnc:owner-from-lot    OWNER-FROM-LOT)
;;   (define gnc:invoice-from-lot    INVOICE-FROM-LOT)
   (define gnc:query-add-guid-match    qof-query-add-guid-match)
   (define gnc:query-set-sort-order    qof-query-set-sort-order)
 ;;  ####    Session Stuff
   (define gnc:session-new    qof-session-new)
   (define gnc:session-get-book    qof-session-get-book )
   ; #### Book stuff
;;   (define gnc:book-get-group    xaccGetAccountGroup)
;;   (define gnc:book-get-template-group    gnc-book-get-template-group)
   (define gnc:book-get-commodity-table    gnc-commodity-table-get-table)
   (define gnc:book-get-pricedb    gnc-pricedb-get-db)
   (define gnc:book-kvp-changed    qof-book-kvp-changed)
   (define gnc:print-date    gnc-print-date)
   (define gnc:commodity-create    gnc-commodity-new)
   (define gnc:commodity-get-exchange-code    gnc-commodity-get-cusip)
   (define gnc:commodity-is-currency?    gnc-commodity-is-currency)
   (define gnc:commodity-equiv?    gnc-commodity-equiv    )
   ;# oops, this gets
   ; some unwanted functions, oh well.
;;   (define gnc:commodity-    gnc-commodity-)
   (define gnc:double-to-gnc-numeric    double-to-gnc-numeric)
;;   (define gnc:numeric-collector    zymurgy)
;;   (define gnc:numeric-    gnc-numeric-)
;;   (define zymurgy    gnc:numeric-collector)
   (define gnc:timepair-canonical-day-time    timespecCanonicalDayTime)
   (define gnc:build-dotgnucash-path    gnc-build-dotgnucash-path)
;;   (define gnc:\*report-hook\*    HOOK-REPORT)
;;   (define gnc:\*save-options-hook\*    HOOK-SAVE-OPTIONS)
   (define gnc:hook-add-dangler    gnc-hook-add-scm-dangler)
   (define gnc:hook-run-danglers-real    gnc-hook-run    )
   ;#### Price stuff
   (define gnc:price-create    gnc-price-create)
   (define gnc:price-get-guid    gncPriceGetGUID)
   (define gnc:price-unref    gnc-price-unref)
   (define gnc:price-set-commodity    gnc-price-set-commodity)
   (define gnc:price-set-currency    gnc-price-set-currency)
   (define gnc:price-set-time    gnc-price-set-time)
   (define gnc:price-set-source    gnc-price-set-source)
;;   (define gnc:price-set-type    gnc-price-set-type)
   (define gnc:price-set-value    gnc-price-set-value)
   (define gnc:price-get-commodity    gnc-price-get-commodity)
   (define gnc:price-get-currency    gnc-price-get-currency)
   (define gnc:price-get-time    gnc-price-get-time)
;    #s    gnc:price-set-source    gnc-price-set-source)
;    #s    gnc:price-set-type    gnc-price-set-type)
   (define gnc:price-get-value    gnc-price-get-value)
   (define gnc:price-list-destroy    gnc-price-list-destroy)
;;   (define gnc:pricedb-    gnc-pricedb-)
   (define gnc:quote-source-set-fq-installed    gnc-quote-source-set-fq-installed)

;;  ( define gnc:get-current-group)   gnc-get-current-group))
  ( define gnc:get-current-book   gnc-get-current-book)
  ( define gnc:gettext-helper   gnc-gettext-helper)
;;  ( define gnc:option-db-   gnc-option-db-)
  ( define gnc:default-currency   gnc-default-currency)
  ( define gnc:default-report-currency   gnc-default-report-currency)
  ( define gnc:default-print-info   gnc-default-print-info)
  ;;( define gnc:option-invoke-callback   gncp_option_invoke_callback)
  ( define gnc:locale-default-iso-currency-code   gnc-locale-default-iso-currency-code)
  ( define gnc:account-get-full-name   gnc-account-get-full-name)
  ( define gnc:commodity-print-info   gnc-commodity-print-info)
  ( define gnc:account-print-info   gnc-account-print-info)
  ( define gnc:share-print-info-places   gnc-share-print-info-places)
  ( define gnc:account-reverse-balance?   gnc-reverse-balance)
  ( define gnc:is-euro-currency   gnc-is-euro-currency)
  ( define gnc:convert-to-euro   gnc-convert-to-euro)
  ( define gnc:convert-from-euro   gnc-convert-from-euro)
  ( define gnc:commodity-table-get-quotable-commodities-info   gnc-commodity-table-get-quotable-commodities)
  ( define gnc:accounting-period-start   gnc-accounting-period-fiscal-start)
  ( define gnc:accounting-period-end   gnc-accounting-period-fiscal-end)
  ( define gnc:amount->string   xaccPrintAmount)

  (define gnc:numeric-zero gnc-numeric-zero)
  (define gnc:numeric-to-double gnc-numeric-to-double)
  (define gnc:numeric-positive-p gnc-numeric-positive-p)
  (define gnc:numeric-add gnc-numeric-add)
  (define gnc:numeric-div gnc-numeric-div)
  (define gnc:numeric-mul gnc-numeric-mul)
  (define gnc:numeric-compare gnc-numeric-compare)
  (define gnc:numeric-abs gnc-numeric-abs)
  (define gnc:numeric-neg gnc-numeric-neg)
  (define gnc:numeric-negative-p gnc-numeric-negative-p)
  (define gnc:numeric-zero-p gnc-numeric-zero-p)
  (define gnc:numeric-sub gnc-numeric-sub)
 ; (define gnc: gnc-)
 (define  gnc:commodity-get-mnemonic gnc-commodity-get-mnemonic)
 (define  gnc:commodity-get-namespace gnc-commodity-get-namespace)
 (define  gnc:commodity-get-printname gnc-commodity-get-printname)
  (define gnc:pricedb-lookup-nearest-in-time-any-currency gnc-pricedb-lookup-nearest-in-time-any-currency)
   (define gnc:pricedb-lookup-latest-before-any-currency gnc-pricedb-lookup-latest-before-any-currency)